/* rec_open - open a record-binary file */
#include "rec_io.h"
REC_FILE rec_files[REC_NFILE] = {0};
rec_fd rec_open(fname, type, recsize)
	char fname[];
	int type;
	int recsize;
	{
	rec_fd fd;
	REC_FILE *rfp;			/* pointer to a REC_FILE entry */
	int old_errno = errno;	/* save system error indicator */
	short i;				/* counter to clear first record */

	errno = 0;				/* clear error indicator */
	fd = bin_open(fname, type);
	if (fd < 0 || fd >= REC_NFILE)	/* validate fd */
		return (-1);
	rfp = &rec_files[fd];
	bin_lseek(fd, (long)0, SEEK_SET);	/* seek to initial byte of file */
	if ((type & O_RWMODE) == O_WRONLY ||	/* new file: opened write-only, or */
		bin_read(fd, rfp, sizeof(*rfp)) != sizeof(*rfp))	/* can't be read */
		{
		bin_lseek(fd, (long)0, SEEK_SET);
		rfp->_byte0 = REC_BYTE0;
		rfp->_recsize = recsize;
		rfp->_nrecs = 0;
		bin_write(fd, rfp, sizeof(*rfp));
		for (i = 1; i <= REC_BYTE0 - sizeof(*rfp); ++i)
			bin_write(fd, "\0", 1);
		}
	else if (recsize != rfp->_recsize)	/* file exists, but bad recsize */
		{
		bin_close(fd);
		return (-1);
		}
	if (errno == 0)
		{
		errno = old_errno;				/* restore saved value */
		bin_lseek(fd, (long)rfp->_byte0, 0);
		rfp->_status = type;			/* save the open-mode of file */
		return (fd);
		}
	else /* error was returned from some bin_io function */
		{
		bin_close(fd);
		return (-1);
		}
	}
